install.packages("rgbif","ALA4R") "parallel","kableExtra","tidyverse", "rasterVis)


packages<-c("rgbif","ALA4R","parallel","kableExtra","tidyverse")

library(rgbif)
Library(ALAR4)
sapply(packages,require,character.only=T)

getwd()
dir()
ls()

(especies<-read.table("especies.txt",sep=";"))

especies<-read.table("especies.txt",sep=";",header=TRUE)

class(especies)

#introducimos el operador $
class(especies$name)

#introducimos los operadores []
class(especies[2])
class(especies[,2])

class(especies[3:5])
class(especies[,5])
dim(especies)
nrow(especies)
ncol(especies)
seq_along(especies)
class(seq_along(especies))
class(1)
class("1")

mis_especies<-c("Geastrum","Viola","Hyla","Eucalyptus")
class(mis_especies)
rm(mis_especies)#eliminar un objeto

matrix(1:9,ncol=3,nrow=3,byrow = TRUE)
matrix(1:9,ncol=3,nrow=3,byrow = FALSE)

#introducimos el pipeline
matrix(1:9,ncol=3,nrow=3,byrow = FALSE)%>%class()

#ALA4R####

library(ALA4R)

#manera 1 de seleccionar los datos
my_especie<-subset(especies,invader ==  TRUE)
my_especie<-subset(my_especie,phylum != "Animal")
my_especie<-subset(my_especie,country == "Australia")
my_especie<-my_especie$name
my_especie<-droplevels(my_especie)

#manera2
my_especie<-subset(especies,invader == TRUE & phylum != "Animal" & country == "Australia")
my_especie<-my_especie$name
my_especie<-droplevels(my_especie)

#manera3

my_especie<-especies[4,1]
my_especie
my_especie<-droplevels(my_especie)


####

#introduccion del operador de pipes
ala_reasons()%>%class()

ALA_occ<-occurrences(taxon=my_especie,
            download_reason_id=3)
occurrences_plot(ALA_occ)
class(ALA_occ)
ALA_occ$data%>%names()
ALA_occ$data%>%class()
ALA_occ$data%>%dim()
ALA_occ<-subset(ALA_occ$data,scientificName=="Acacia dealbata")
ALA_occ%>%dim()
ALA_occ<-ALA_occ[22:23]
colnames(ALA_occ)<-c("y","x")
colnames(ALA_occ)
library(sp)
plot(aus)
points(x=ALA_occ$x,y=ALA_occ$y)




#rgbif

library(rgbif)
RGBIF_occ0<-occ_search(scientificName = "Acacia dealbata")
str(RGBIF_occ0)
RGBIF_occ1<-occ_search(scientificName = "Acacia dealbata", hasCoordinate=TRUE,return="data")
str(RGBIF_occ1)
dim(RGBIF_occ1)
class(RGBIF_occ1)
RGBIF_occ1

RGBIF_occ2<-occ_search(scientificName = "Acacia dealbata", hasCoordinate=TRUE,return="data",limit=15000)
names(RGBIF_occ2)
RGBIF_occ2[3]
RGBIF_occ2[4]
RGBIF_occ2[48]
RGBIF_occ2["country"]

GBIF_occ<-RGBIF_occ2%>%select(decimalLatitude,decimalLongitude,country)
GBIF_occ<-select(RGBIF_occ2(decimalLatitude,decimalLongitude,country)
ggplot(GBIF_occ,aes(x=decimalLongitude,y=decimalLatitude))+geom_point()
plot(aus)
points(x=GBIF_occ$decimalLongitude,GBIF_occ$decimalLatitude)
points(x=ALA_occ$x,y=ALA_occ$y,col="green")

GBIF_occ<-RGBIF_occ2%>%
  select(decimalLatitude,decimalLongitude,country)%>%
  filter(country=="Spain" | country== "Australia")#introducimos el operador lógico |

GBIF_occ<-subset(RGBIF_occ2,country== "Spain" | country== "Australia")
GBIF_occ<-GBIF_occ[c(3,4,48)]

#bajando las capas de worldclim####

dir.create("WorldClim_data", showWarnings = F)
## curent bioclim
download.file(url = "http://biogeo.ucdavis.edu/data/climate/worldclim/1_4/grid/cur/bio_10m_esri.zip", 
              destfile = "WorldClim_data/current_bioclim_10min.zip", 
              method = "auto")
unzip( zipfile = "WorldClim_data/current_bioclim_10min.zip", 
       exdir = "WorldClim_data/current", 
       overwrite = T)
list.files("WorldClim_data/current/bio/")
bioclim_world <- stack(list.files("WorldClim_data/current/bio", pattern ="bio_", full.names=T), RAT = FALSE)
plot(bioclim_world)
class(bioclim_world)
bioclim_world$bio_1
plot(bioclim_world$bio_12)
points(x=GBIF_occ$decimalLongitude,y=GBIF_occ$decimalLatitude,col=GBIF_occ$country)#no funciona porque no es un factor
points(x=GBIF_occ$decimalLongitude,y=GBIF_occ$decimalLatitude,col=as.factor(GBIF_occ$country)) #convertimos a factor

#extracción de los datos:
bio_data<-GBIF_occ[1:2]%>%raster::extract(bioclim_world,.,df=TRUE)#coordenadas invertidas
head(bio_data)
bio_data<-GBIF_occ[c(2,1)]%>%raster::extract(bioclim_world,.,df=TRUE)#coordenadas arregladas
bio_data<-cbind(bio_data,GBIF_occ)

#algunas estadísticas
summary(bio_data)
colMeans(bio_data[2:ncol(bio_data)-1])#eliminamos el ID y las columnas no numéricas
bio_data$ID<-NULL
?aggregate
aggregate(bio_data,by=list(bio_data$country),FUN=mean)#sin usar fórmula
boxplot(bio_1~country,data=bio_data)
#y si tuviéramos que hacerlo para todos los casos..?
t.test(bio_1~country,data=bio_data)
hist(bio_data$bio_1,main="Histograma")

install.packages("factoextra")
library(factoextra)
library(FactoMineR)
pca_adealbata<-PCA(bio_data[2:19])
fviz_pca(pca_adealbata,col.ind=bio_data$country)

#GGPLOT####
#Filosofía tidy data####
(ghg_tidy<-read_csv("GHG.csv"))#Usamos el paquete base para cargar.
(ghg_tidy<-read_csv2("GHG.csv"))#usamos tidyverse para subir los datos. Tendríamos que utilizar parse_double para mejorarlo...o algo parecido:type convert

(ghg<-read.csv("GHG.csv",sep=";",header=TRUE))
ghg_tidy<-read_csv2("GHG.csv")%>%
  type_convert()
 
ghg_tidy<-ghg_tidy%>%gather(3:10,key="year",value="ghg")#convertimos en formato largo
ghg_tidy
filter(ghg_tidy,Country=="Algeria")#miramos los datos de argelia
ghg_tidy$year<-parse_date(ghg_tidy$year,format="%Y")  #convertimos los datos de año en fecha
ghg_tidy

#aplicación estadística####
lm_ghg<-lm(ghg~Continent+year,data=ghg_tidy)
summary(lm_ghg)
anova(lm_ghg)

lm_ghg2<-lm(ghg~year,data=ghg_tidy)
summary(lm_ghg2)
anova(lm_ghg2)

ghg_tidy$Continent<-parse_factor(ghg_tidy$Continent,levels=ghg_tidy$Continent)

library(lmerTest)
lmer_ghg<-lmerTest::lmer(ghg~year+(1|Continent),data=ghg_tidy)
summary(lmer_ghg)

#visualización eficiente con ggplot####

data(iris)
head(iris)
plot(iris$Sepal.Length,iris$Petal.Length)
plot(iris$Sepal.Length,iris$Petal.Length,col=as.factor(iris$Species))

iris_plot<-ggplot(iris,aes(x=Sepal.Length,y=Petal.Length))
iris_plot+geom_point()
iris_plot+geom_point(aes(col=Species))
iris_plot+geom_point(aes(col=Species,size=Sepal.Width))

#manejando el tamaño según un parámetro
iris_plot+geom_point(aes(shape=Species,size=Sepal.Width))

#escala continua de color

iris_plot+geom_point(aes(shape=Species,col=Sepal.Width))+
  scale_colour_gradient(low = "green", high = "red")#cambiamos en esta línea la escala por defecto

#con más parámetros
iris_plot+geom_point(aes(col=Species))+
  xlab("Longitud del sépalo")+
  ylab("Longitud del pétalo")+
  theme_bw()+#atajo al tema blanco y negro
  ggtitle("Relación morfométrica en Iris")+
  geom_smooth()+
  geom_smooth(method="lm")


#volvemos a GHG como ejemplo de mapeo estadístico
ggplot(ghg_tidy,aes(x=year,y=ghg))+geom_point()
ggplot(ghg_tidy,aes(x=year,y=ghg))+geom_boxplot()
ggplot(ghg_tidy,aes(x=year,y=ghg,group=Continent))+geom_boxplot()
ggplot(ghg_tidy,aes(x=Continent,y=ghg,fill=Continent))+
  geom_boxplot()+
  facet_grid(.~year)

ghg_NAEU<-filter(ghg_tidy,Continent=="North America" | Continent == "Europe")
ggplot(ghg_NAEU,aes(x=Continent,y=ghg,fill=Continent))+
  geom_boxplot()+
  facet_grid(.~year)

ggplot(ghg_NAEU,aes(x=year,y=ghg,group=Continent))+
  geom_point()+
  geom_smooth()

ggplot(ghg_NAEU,aes(x=year,y=ghg,col=Continent))+
  geom_point()+
  geom_smooth()


best_in_class <- ghg_NAEU %>%
  group_by(Continent) %>%
  filter(row_number(desc(ghg)) == 1)

ggplot(ghg_NAEU,aes(x=year,y=ghg,col=Continent))+
  geom_point()+
  geom_smooth()+
  geom_point(size = 3, shape = 1, data = best_in_class)

library(ggrepel)

ggplot(ghg_NAEU,aes(x=year,y=ghg,col=Continent))+
  geom_point()+
  geom_smooth()+
  geom_point(size = 3, shape = 1, data = best_in_class)+
  ggrepel::geom_label_repel(aes(label = Country), data = best_in_class)

#ejemplos con RGBIF
head(bio_data)
ggplot(bio_data,aes(x=bio_1,col=country))+geom_histogram()
ggplot(bio_data,aes(x=bio_1,fill=country))+geom_histogram(bins=45)
ggplot(bio_data,aes(x=bio_1,col=country))+geom_density()
ggplot(bio_data,aes(x=bio_1,fill=country))+geom_density(aes(alpha=2/3))

ggplot(bio_data,aes(x=decimalLongitude, y=decimalLatitude))+geom_point(aes(col=country,size=bio_1))
ggplot(bio_data,aes(x=decimalLongitude, y=decimalLatitude))+geom_point(aes(shape=country,size=bio_1))
class(aus)
ggplot(as.data.frame(aus,xy=TRUE),aes(x,y))+geom_raster(z)

#quitando la leyenda
ggplot(bio_data,aes(y=bio_1,x=country))+stat_boxplot(geom="errorbar")+
  geom_boxplot(aes(fill=country))+
  scale_fill_discrete(guide=FALSE)#esta línea de código quita la leyenda
  
#cambiar el orden de las apariciones
class(bio_data$country) #nos aseguramos de que es un factor: no lo es
bio_data$country<-factor(bio_data$country,levels=c("Spain","Australia"))

#Mapping variable values to colors
ggplot(bio_data,aes(y=bio_1,x=country))+stat_boxplot(geom="errorbar")+
  geom_boxplot(aes(fill=country))+
  #scale_fill_discrete(guide=FALSE)+
  scale_fill_manual(values=c("#CC6666", "#9999CC"))

#diagramas de barras: emisiones per capita promedio por continente en 2015

ghg_sum<-ghg_tidy%>%filter(year=="2015-01-01" & Continent != "NA")%>% #filtramos y solo nos quedamos los de 2015
  group_by(Continent)%>%
  summarize(ghg=mean(ghg))

ggplot(ghg_sum,aes(x=Continent,y=ghg))+geom_bar(stat="identity")+
  theme_classic()

ghg_tidy%>%filter(year=="2015-01-01" & Continent == "Asia")%>%  #filtramos y solo nos quedamos los de 2015 de Asia
  #arrange(desc(ghg)) #para usar tras el primer intento
  ggplot(aes(x=Country,y=ghg))+
  geom_bar(stat="identity")+
  theme(axis.text.x = element_text(angle = 45, hjust = 1))
  
ghg_tidy%>%filter(year=="2015-01-01" & Continent == "Asia")%>%  #filtramos y solo nos quedamos los de 2015 de Asia
  arrange(asc(ghg)) #para usar tras el primer intento

subset(ghg_tidy,Country=="China")%>%
  ggplot(aes(x=year,y=ghg))+
  geom_line()

subset(ghg_tidy,Country=="Germany" | Country=="Spain and Andorra")%>%
  ggplot(aes(x=year,y=ghg))+
  geom_line(aes(col=Country))+ 
  scale_colour_discrete(name  ="País",labels=c("Alemania", "España"))

#Sobre coordenadas

library(ggmap)

mapImageData1 <- get_map(location = c(lon = -3.6030016179, lat = 40.348425),
                         color = "color",
                         source = "google",
                         maptype = "satellite",
                         zoom = 6)
ggmap(mapImageData1)+
  geom_point(data=bio_data,aes(x=decimalLongitude,y=decimalLatitude,col="yellow"))

aqui<-geocode("Jardin Botanico,Madrid,Spain")
aqui
ggmap(get_map(aqui),zoom=4)+geom_point(data=aqui,aes(lon,lat),size=4)

######### Programación ######

#regla de oro de la programación: no repetir código, 2, 3 veces.
#Ejemplos de bucle for

for (i in 1:10){
  print (i*10)
}

especies

for (s in especies$name){
  message(paste("La especie es",s),appendLF=TRUE)
  }

for (s in especies$name){
  print(paste("La especie es",s))
}

for (s in especies$name){
  cat(paste("La especie es",s))
}

#jugando con los índices
for (i in 1:nrow(especies)){ #i se va convirtiendo en un número de 1 hasta el número de filas que tenga el marco de datos
  especie<-especies[i,1] #creamos el objeto especies, que corresponde a la fila i, columna 1
  ncomun<-especies[i,3]
  print(paste(especie,":",ncomun)) #lo concatenamos
}

#recorriendo columnas

for (i in seq_along(bio_data[1:21])){#seq_along previene números extraños; pero hay datos no numéricos, de ahí el 1
  class(bio_data[i])%>%print()
  print(mean(bio_data[,i]))
}
#algo más eficiente:
colMeans(bio_data[1:21])
colMeans(bio_data[1:21])%>%class()
#nos hemos dejado la manera de poder almacenar nuestros resultados:

mis_medias<-c() #aquí vamos a tener un problema de engorde de vectores
for (i in seq_along(bio_data[1:21])){#seq_along previene números extraños; pero hay datos no numéricos, de ahí el 1
  #print(mean(bio_data[,i])) #ya no nos interesa visualizar sino almacenar
  media<-mean(bio_data[,i])
  mis_medias[i]<-media
}
mis_medias

#sin problemas de engorde de vectores:
mis_medias<-c(rep(NA,ncol(bio_data[1:19]))) #anticipamos la longitud del vector
for (i in seq_along(bio_data[1:21])){#seq_along previene números extraños; pero hay datos no numéricos, de ahí el 1
  #print(mean(bio_data[,i])) #ya no nos interesa visualizar sino almacenar
  media<-mean(bio_data[,i])
  mis_medias[i]<-media
}

#hacemos un dataframe para almacenar más variables
mis_medias<-data.frame(variable=character(),media=double()) #o bien sin engorde de vectores
mis_medias<-matrix(NA,ncol=2,nrow=ncol(bio_data)-1)%>%as.data.frame()
head(mis_medias)
colnames(mis_medias)<-c("variable","media")
for (i in seq_along(bio_data[1:21])){#seq_along previene números extraños; pero hay datos no numéricos, de ahí el 1
  #print(mean(bio_data[,i])) #ya no nos interesa visualizar sino almacenar
  mis_medias[i,1]<-colnames(bio_data[i]) #coloco el nombre de la variable en su celda
  mis_medias[i,2]<-mean(bio_data[,i]) #calculo la media y la escribo en su celda. #ojo, tengo que especificar con la coma que es un vector
}
head(mis_medias)

#while:primer ejemplo

i<-0
while (i<5){
  print(i)
  #i+1 si dejamos esto tal cual es un bucle infinito
  i<-i+1
}

#tirada de dados. Si sacamos 6 dejamos de tirar
dado<-0
while (dado!=6){
  #dado<-runif(n=1,min=1,max=6)#distribución aleatoria entre 1 y 6
  dado<-sample(1:6,size=1)#distribución aleatoria entre 1 y 6
  message(paste("Tu resultado es",dado),appendLF=TRUE)
  
}

#foreach: enlace en markdown

#sapply, lapply y apply

apply(bio_data[1:19],2,FUN=mean)

packages<-c("rgbif","ALA4R","kableExtra","parallel","kableExtra","tidyverse")
sapply(packages,require,character.only=T)

lapply(packages,require,character.only=T)
mean(bio_data)

for(i in especies$name){
  print(paste("Searching",i))
  occ_search(scientificName = i)%>%print()
}

sapply(especies$name,occ_search)

#condicionales if else ifelse

for (i in 1:nrow(especies)){
  if (especies[i,5] == TRUE){
    print (paste(especies[i,1],"es invasora"))
  } else {
    print(paste(especies[i,1],"es autóctona"))
  }
}


for (i in 1:nrow(especies)){
  if (especies[i,5] == TRUE){
    print (paste(especies[i,1],"es invasora"))
  } else {
    print(paste(especies[i,1],"es autóctona"))
  }
}

#introducir break y repeat
tiradas<-0
repeat{
  dado1<-sample(1:6,size=1)
  dado2<-sample(1:6,size=1)
  tiradas<-tiradas+1
  if(dado1==5 & dado1==dado2){
    message("Has sacado doble 5")
    print(tiradas)
    print(paste("Probabilidad",1/tiradas, "teórica:", 1/36))
    break
  } else {
    message(paste("dado1",dado1,"dado2", dado2))
    message(tiradas)
  }
}


mis_datos<-list()
for (i in 1:nrow(especies)){
  if (especies[i,5] == TRUE){
    print (paste(especies[i,1],"es invasora"))
    temp_occ<-occ_search(scientificName = toString(especies[i,1]))#el toString es una ñapa para factores
    mis_datos<-list(mis_datos,temp_occ)
  } else {
    print(paste(especies[i,1],"es autóctona"))
    temp_occ<-occ_search(scientificName = toString(especies[i,1]),country = "ES")
    mis_datos<-list(mis_datos,temp_occ)
    }
    
}

mis_datos
str(mis_datos)
rm(mi_datos)

##### ejercicio guiado ##### 
#buscar en bucle en gbif las coordenadas de las especies.
#Si son autóctonas, visualizar sus coordenadas
#Si son invasoras, contrastar con un boxplot los datos de dos variables bioclimáticas

### mi solución: ##

for (i in 1:nrow(especies)){
  if (especies[i,5] == TRUE){
    print (paste(especies[i,1],"es invasora"))
    message("Searching occurrences")
    temp_occ<-occ_search(scientificName = toString(especies[i,1]),limit=2000)
    temp_occ<-data.frame(temp_occ$data)
    temp_occ<-cbind(temp_occ["decimalLongitude"],temp_occ["decimalLatitude"],temp_occ["country"])#invertimos el orden de la latitud y la longitud (3 y 4)
    biodata<-temp_occ[c(1,2)]
    message(paste("Extracting data from raster for species",especies[i,1]))
    biodata<-raster::extract(x=bioclim_world,y=biodata,df=TRUE)
    biodata<-cbind(biodata,temp_occ)
    biodata<-biodata[-c(1,24:26)]
    biodata_plot_boxplot12<-ggplot(biodata,aes(x=country,y=bio_12))+
      stat_boxplot(geom="errorbar")+geom_boxplot()+ggtitle(paste("Range of precipitation of",especies[i,1]))
    print(biodata_plot_boxplot12)
    biodata_plot_boxplot10<-ggplot(biodata,aes(x=country,y=bio_10))+
      stat_boxplot(geom="errorbar")+geom_boxplot()+ggtitle(paste("Average temperature of",especies[i,1]))
    print(biodata_plot_boxplot10)
  } else {
    print(paste(especies[i,1],"es autóctona"))
    temp_occ<-occ_search(scientificName = toString(especies[i,1]))
    temp_occ<-data.frame(temp_occ$data)
    temp_occ<-cbind(temp_occ["decimalLongitude"],temp_occ["decimalLatitude"],temp_occ["country"])#invertimos el orden de la latitud y la longitud (3 y 4)
    biodata<-temp_occ[c(1,2)]
    message(paste("Extracting data from raster for species",especies[i,1]))
    biodata<-raster::extract(bioclim_world,biodata,df=TRUE)
    biodata<-cbind(biodata,temp_occ)
    biodata<-biodata[-c(1,24:26)]
    biodata_plot<-ggplot(biodata,aes(x=decimalLongitude,y=decimalLatitude))+
      geom_point(aes(col=country))+ggtitle(especies[i,1])
    print(biodata_plot)
  }
  
}

#Otros ejercicios:

  #Tirar 1000 veces dos dados e imprimir en pantalla la proporción de dobles 5 en relación a la teoría
  
  contador<-0
  for (n in 1:1000){
    dice1<-sample(1:6,size=1)
    dice2<-sample(1:6,size=1)
    if(dice1==5 & dice1==dice2){
      contador=contador+1
      print("acierto")
    }
  }
  
  message(paste(contador/1000,1/36))
  
  
  #y si teenemos que hacer 100 simulaciones? 1000? 10000
  nsimulations=10000
  contador=0
  for (n in 1:nsimulations){
    dice1<-sample(1:6,size=1)
    dice2<-sample(1:6,size=1)
    if(dice1==5 & dice1==dice2){
      contador=contador+1
      print(paste("acierto, contador:",contador))
    }
  }
  
  message(paste(contador/nsimulations,1/36))

#creando nuestras propias funciones con R ####

#y si lo tienes que hacer con un dado de 10 caras?

#coge el siguiente código y extraer la función. ¿qué ha pasado? ¿qué hace la función?  
  contador=0
  for (n in 1:nsimulations){
    dice1<-sample(1:6,size=1)
    dice2<-sample(1:6,size=1)
    if(dice1==5 & dice1==dice2){
      contador=contador+1
      print(paste("acierto, contador:",contador))
    }
  }


#cuál es la diferencia con el código anterior?
  
  contador=0
  for (n in 1:nsimulations){
    dice1<-sample(1:caras,size=1)
    dice2<-sample(1:caras,size=1)
    if(dice1==5 & dice1==dice2){
      contador=contador+1
      print(paste("acierto, contador:",contador))
    }
  }
  
  dado(10,6)
  
#vamos a arreglar la función: valores por defecto, dar un retorno decente.  
  
  dado<-function(nsimulations=100, caras=6) {
    contador=0
    for (n in 1:nsimulations){
      dice1<-sample(1:caras,size=1)
      dice2<-sample(1:caras,size=1)
      if(dice1==5 & dice1==dice2){
        contador=contador+1
        #print(paste("acierto, contador:",contador)) #lo quitamos para que no moleste tanto print
      }
    }
    return(contador/nsimulations)
  }
  
  
dado()
mi_proporcion<-dado()
mi_proporcion  

simulaciones<-c(1,10,100,1000,10000,100000,100000)
sapply(simulaciones,dado,caras=6)

for (s in simulaciones){
  print(s)
  dado(s,caras=6)%>%print()
}

#qué función es más rápida...?
install.packages("microbenchmark")
library(microbenchmark)

microbenchmark(for (s in simulaciones){
  print(s)
  dado(s,caras=6)%>%print()
}, sapply(simulaciones,dado,caras=6),times=10)

#construir un conversor de temperaturas Fahrenheit a Celsius. C=(F-32)*5/9


#simplificar el uso de RGBIF: construir una función que saque un mapa de distribución con ggplot a partir del nombre científico

#mi solución

migbif<-function(nombre=NULL){
  mydata<-occ_search(scientificName = nombre,country="ES",limit=2000)
  mydata<-mydata$data
  mydata<-cbind(mydata["decimalLongitude"],mydata["decimalLatitude"])
  my_plot<-ggplot(mydata,aes(x=decimalLongitude,y=decimalLatitude))+
    geom_point()+ggtitle(paste("Distribución de",nombre))
  print(my_plot)
}

migbif("Lavandula lanata")

#otra comparación: media() vs. mean()
media<-function(columna){
  suma<-sum(columna)
  promedio<-suma/length(columna)
  return(promedio)
}
media(c(4,6))
datos_random<-rnorm(100000,3,5)

#y ahora los comparamos: ocurre algo completamente inesperado para mí.
microbenchmark(media(datos_random),mean(datos_random),times=30)%>%
  boxplot()


media(datos_random)
mean(datos_random)
