setwd("C:/Users/AGonzalez/OneDrive - Christian Aid/INDCs")

library(tidyverse)
library(ggplot2)
library(directlabels)

ghg_tidy<-read_csv2("GHG.csv")
ghg<-read.csv("GHG.csv",sep=";",header=TRUE)

ghg_tidy$Continent<-parse_factor(ghg_tidy$Continent,levels=NULL)

lac<-filter(ghg_tidy,Continent=="LAC")%>%
  gather("1990","2000","2005","2010","2012","2014","2015","2016",key="year",value="ghg")
lac$ghg<-lac$ghg%>%parse_double()
lac$year<-parse_date(lac$year,format="%Y")
ggplot(lac,aes(x=year,y=ghg))+geom_point(aes(col=Country))+geom_line(aes(group=Country))+
  theme_bw()+xlab("YEAR")+ylab("Greenhouse gases emissions")+
  scale_colour_discrete(guide = 'none') +
  geom_smooth()
  geom_dl(aes(label = Country), method = list(dl.combine("first.points", "last.points"), cex = 0.8))
  
arrange(lac,-ghg)
lac<-filter(lac,Country !="Curacao")
lac<-filter(lac,Country !="Trinidad and Tobago")


#GDP
gdp<-read_delim("GDP.csv",delim=",")
drop.cols<-c("Country Code","Indicator Name", "Indicator Code")
gdp<-gdp%>%select(-starts_with("19"))%>%
  select(-one_of(drop.cols))%>%
  rename("Country"="Country Name")
gdp_years<-colnames(gdp[2:19])
gdp<-gdp%>%  gather(gdp_years,key="year",value="gdp")
gdp[2]<-NULL
gdp$year<-parse_date(gdp$year,format="%Y")
gdp$gdp<-parse_double(gdp$gdp)

ghgdp<-left_join(lac,gdp,by=c("Country"="Country","year"="year"))%>%
  drop_na()

ggplot(ghgdp,aes(year,ghg))+
  geom_point(aes(size=log(gdp)))

ggplot(ghgdp,aes(log(gdp),ghg))+
  geom_point(aes(col=year))

ggplot(ghgdp,aes(y=(ghg/gdp),x=year))+
  geom_point(aes(col=Country,size=gdp))+
  geom_smooth()
